## Intro

what we will do:
- examine an important work of generative art in processing 
- in the process, learn about:
    - how simple rules can generate complexity 
    - usages of randomness 
    - learn a bit more about programming in processing 

## Substrate

- show the work, talk about the author 
- ask students to explain how it works (in the simpler version)

## Randomness

- explain randomness in computers
- randomness in processing

## Substrate algorithm and code

- present the algorithm (pseudo code)
- present the problems 
- present the code (simplified version)

## More subtle Randomness

- present the other usages of randomness in the opera

## Playing with substrate (the simplified version)





[Jared Tarbell Substrate](http://www.complexification.net/gallery/machines/substrate/), June 2003

In Tarbell’s own words:

A single line (known internally as a “crack”) begins drawing itself from some random point in some random direction. The line continues to draw itself until it either (a) hits the edge of the screen or (b) hits another line, at which point it stops and two more lines begin. The one simple rule used in the creation of new lines is that they begin at tangents to existing lines. This process is repeated until there are too many lines to keep track of or the program is stopped.

In its essence, the algorithm is as follows:

- to know where we can draw, we create a grid (a table) of numbers, the same size of the screen, and initialize each cell at 10001 (which means it is empty). During execution, a cell will marked as occupied by a line by writing in the cell the direction of the line, expressed as the angle of the line (in degrees)

- at the beginning, 16 random cells of the grid are initialized to a random angle

- 3 cracks are created. A crack is not really a line, it is actually a point (on a line) and a direction (of the line)

- to generate a crack, we need to:
    - find its starting point:
        - find a random occupied cell on the grid
        - choose randomly between the two perpendicular directions to the cell direction  
    - the crack point is computed as the position of the cell, plus a 0.61 translation in the chosen direction

- at each frame, we move all created cracks. Moving a crack means drawing a new point in the direction of the crack (i.e., we "grow" the crack line). To move a crack, we:
    - move the crack point 0.42 in the direction of the crack 
    - draw the point
    - check if we have reached the border or another crack. To check, we just need to check the value of the new cell we have reached by moving the point 
        - if no: the cell corresponding to the point we have drawn is filled with the value of the direction 
        - if yes: we stop the current crack, and start two new cracks 

Jared also makes little uses of randomness to make the ouput more interesting:
- when drawing the point of a crack, the point is moved by a small random value. This makes the drawing more irregular, and similar to a hand-drawn result
- the perperndicular direction is randomly perturbed a little (max +/- 2 degrees)
- the check with the borders and the other cracks is done with a small random offset 

The version of the algorithm by Tarbell also features a drawing technique, which is called Sand Painting 

With Sand Painting, when drawing a point, we select a direction perpendicular to the crack direction, and "sand paint" all free space in that direction (i.e., a line). To "sand paint" a line, we:
- choose a random color (the random color will stay the same for all the points in the current crack)
- lay down grains of sand (transparent pixels) along the line (64 grains)
- the position of each grain is perturbed (wrt its position in the line) using random values inside sin functions
- the palette of colors is chosen from an image
  
